unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, Menus, ReadBDEIni, Registry, IniFiles;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    OpenBDEINIFile1: TMenuItem;
    CloseBDEINIFile1: TMenuItem;
    N1: TMenuItem;
    E7xit1: TMenuItem;
    View1: TMenuItem;
    INIFileA1: TMenuItem;
    N2: TMenuItem;
    RefreshList1: TMenuItem;
    N3: TMenuItem;
    ApplytoRegistry1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    TView: TTreeView;
    Label1: TLabel;
    lblValue: TLabel;
    SB: TStatusBar;
    OpenIni: TOpenDialog;
    procedure E7xit1Click(Sender: TObject);
    procedure OpenBDEINIFile1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CloseBDEINIFile1Click(Sender: TObject);
    procedure TViewChange(Sender: TObject; Node: TTreeNode);
    procedure ApplyToRegistry1Click(Sender: TObject);
  private
    { Private declarations }
    BDEIni: TSetupBDE;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.E7xit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.OpenBDEINIFile1Click(Sender: TObject);
begin
  if OpenIni.InitialDir = '' then
    OpenIni.InitialDir := ExtractFilePath(Application.ExeName);

  if OpenIni.Execute = True then
  begin
    OpenIni.InitialDir := ExtractFilePath(OpenIni.FileName);
    Caption := 'Network BDE Registry Update Example (' +  OpenIni.FileName + ')';
    BDEIni := TSetupBDE.Create(OpenIni.FileName, TView);
    BDEIni.Refresh;
  end;
  CloseBDEINIFile1.Enabled := True;
  ApplyToRegistry1.Enabled := True;
end;


procedure TMainForm.FormCreate(Sender: TObject);
begin
  BDEIni := nil;
  lblValue.Caption := '';
  CloseBDEINIFile1.Enabled := False;
  ApplyToRegistry1.Enabled := False;
  Caption := 'Network BDE Registry Update Example';
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  if BDEIni <> nil then
    BDEIni.Free;
end;

procedure TMainForm.CloseBDEINIFile1Click(Sender: TObject);
begin
  TView.Items.Clear;
  BDEIni.Free;
  BDEIni := nil;
  CloseBDEINIFile1.Enabled := False;
  ApplyToRegistry1.Enabled := False;
  Caption := 'Network BDE Registry Update Example';
end;

procedure TMainForm.TViewChange(Sender: TObject; Node: TTreeNode);
begin
  if TView.Selected.Level = 0 then
  begin
    Label1.Caption := 'Value:';
    lblValue.Caption := '< No Item Selected>';
  end;
  if TView.Selected.Level = 1 then
  begin
    Label1.Caption := 'Value for ' + TView.Selected.Text + ':';
    lblValue.Caption := BDEIni.GetAsString(TView.Selected.Parent.Text, TView.Selected.Text);
  end;
end;

procedure TMainForm.ApplyToRegistry1Click(Sender: TObject);
begin
  screen.cursor := crHourGlass;
  SB.SimpleText := 'Updating / creating registry entries. Please wait...';
  Application.ProcessMessages;
  try  try
    BDEIni.RegisterBDE(True);
    SB.SimpleText := 'Update / create successful';
    if MessageDlg('Update successful.  Would you like to do a basic BDE ' +
         'initialization test', mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      BDEIni.TestBDE;
  except
    SB.SimpleText := 'An error occurred';
    ShowMessage(Exception(ExceptObject).Message);
  end;

  finally
    screen.cursor := crDefault;
  end;

end;

end.
